(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/overlay'), require('@angular/cdk/portal'), require('@angular/core'), require('@angular/forms'), require('rxjs'), require('rxjs/operators'), require('markdown-it'), require('markdown-it-task-lists'), require('@angular/platform-browser'), require('@angular/cdk/text-field'), require('@angular/common'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/material/list')) :
    typeof define === 'function' && define.amd ? define('ng-simple-markdown-editor', ['exports', '@angular/cdk/overlay', '@angular/cdk/portal', '@angular/core', '@angular/forms', 'rxjs', 'rxjs/operators', 'markdown-it', 'markdown-it-task-lists', '@angular/platform-browser', '@angular/cdk/text-field', '@angular/common', '@angular/material/button', '@angular/material/icon', '@angular/material/list'], factory) :
    (global = global || self, factory(global['ng-simple-markdown-editor'] = {}, global.ng.cdk.overlay, global.ng.cdk.portal, global.ng.core, global.ng.forms, global.rxjs, global.rxjs.operators, global.MarkdownIt, global.TaskList, global.ng.platformBrowser, global.ng.cdk.textField, global.ng.common, global.ng.material.button, global.ng.material.icon, global.ng.material.list));
}(this, (function (exports, overlay, portal, core, forms, rxjs, operators, MarkdownIt, TaskList, platformBrowser, textField, common, button, icon, list) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var EditorHistory = /** @class */ (function () {
        function EditorHistory(content, selectionStart, selectionEnd) {
            this.content = content;
            this.selectionStart = selectionStart;
            this.selectionEnd = selectionEnd;
        }
        return EditorHistory;
    }());

    var NgSimpleMarkdownMentionsComponent = /** @class */ (function () {
        function NgSimpleMarkdownMentionsComponent() {
            this.count = new core.EventEmitter(true);
            this.destroy = new core.EventEmitter(true);
            this.selected = new core.EventEmitter(true);
            this.activeIndex = 0;
            this.items = [];
        }
        NgSimpleMarkdownMentionsComponent.prototype.keyboardEvent = function (event) {
            // get key press
            var key = event.key.toLowerCase();
            // check action
            switch (key) {
                case 'enter': {
                    if (this.items.length > 0) {
                        this.onClick(this.activeIndex);
                        // stop event
                        event.preventDefault();
                        event.stopPropagation();
                    }
                    break;
                }
                case 'escape': {
                    this.destroy.emit();
                    // stop event
                    event.preventDefault();
                    event.stopPropagation();
                    break;
                }
                case 'arrowdown': {
                    if (this.items.length > 0) {
                        // increase index
                        this.activeIndex++;
                        // check overflow
                        if (this.activeIndex > this.items.length - 1) {
                            this.activeIndex = 0;
                        }
                        // stop event
                        event.preventDefault();
                        event.stopPropagation();
                    }
                    break;
                }
                case 'arrowup': {
                    if (this.items.length > 0) {
                        // increase index
                        this.activeIndex--;
                        // check overflow
                        if (this.activeIndex < 0) {
                            this.activeIndex = this.items.length - 1;
                        }
                        // stop event
                        event.preventDefault();
                        event.stopPropagation();
                    }
                    break;
                }
            }
        };
        NgSimpleMarkdownMentionsComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.subscription = this.data.subscribe(function (items) {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
                _this.items = __spread(items);
                _this.count.emit(_this.items.length);
            });
        };
        NgSimpleMarkdownMentionsComponent.prototype.ngOnDestroy = function () {
            if (this.subscription) {
                this.subscription.unsubscribe();
            }
        };
        Object.defineProperty(NgSimpleMarkdownMentionsComponent.prototype, "hasResult", {
            get: function () {
                return this.items && this.items.length > 0;
            },
            enumerable: false,
            configurable: true
        });
        NgSimpleMarkdownMentionsComponent.prototype.onClick = function (index) {
            this.selected.emit(this.items[index]);
        };
        return NgSimpleMarkdownMentionsComponent;
    }());
    NgSimpleMarkdownMentionsComponent.decorators = [
        { type: core.Component, args: [{
                    template: "<mat-nav-list dense class=\"ng-simple-markdown-editor-mentions\" *ngIf=\"hasResult\">\n\t<a\n\t\tmat-list-item\n\t\t*ngFor=\"let item of items; let i = index\"\n\t\tclass=\"ng-simple-markdown-editor-mentions__item\"\n\t\t[class.ng-simple-markdown-editor-mentions__item--active]=\"activeIndex === i\"\n\t\t(click)=\"onClick(i)\"\n\t>\n\t\t<ng-container *ngTemplateOutlet=\"template ? template : defaultTemplate; context: { item: item }\"></ng-container>\n\t\t<ng-template #defaultTemplate>{{item}}</ng-template>\n\t</a>\n</mat-nav-list>\n",
                    styles: [".ng-simple-markdown-editor-mentions{background-color:#fff;border:1px solid #ccc}.ng-simple-markdown-editor-mentions__item{-moz-user-select:none;-ms-user-select:none;-webkit-user-select:none;user-select:none}.ng-simple-markdown-editor-mentions__item--active{background-color:#eee}"]
                },] }
    ];
    NgSimpleMarkdownMentionsComponent.propDecorators = {
        data: [{ type: core.Input }],
        template: [{ type: core.Input }],
        count: [{ type: core.Output }],
        destroy: [{ type: core.Output }],
        selected: [{ type: core.Output }],
        keyboardEvent: [{ type: core.HostListener, args: ['document:keydown', ['$event'],] }]
    };

    var NgSimpleMarkdownMentionDirective = /** @class */ (function () {
        function NgSimpleMarkdownMentionDirective(elementRef, overlay) {
            this.elementRef = elementRef;
            this.overlay = overlay;
            this.searchResult = new core.EventEmitter(true);
            this.searchTerm = new core.EventEmitter(true);
            this.menuOpened = false;
            this.itemCount = 0;
            this.triggerCharPosition = 0;
            this.triggerChar = '';
            this.triggerTerm = '';
            this.triggerMap = {};
            this.searchTermDebounce = new rxjs.Subject();
        }
        NgSimpleMarkdownMentionDirective.prototype.onInput = function (event) {
            // check if any trigger
            if (!this.configs) {
                return;
            }
            // when typed text
            if (event.inputType === 'insertText' && event.data) {
                // get the last char
                var char = Array.from(event.data).pop();
                // exit when typed space
                if (char === ' ') {
                    this.closeMenu();
                    return;
                }
                // check if char in trigger map
                if (this.triggerMap[char]) {
                    // if already searching, terminate the search
                    if (this.menuOpened) {
                        this.closeMenu();
                        return;
                    }
                    // save action trigger
                    this.triggerCharPosition = this.elementRef.nativeElement.selectionEnd;
                    this.triggerChar = char;
                    // open menu
                    this.openMenu();
                }
                else {
                    // emit search term when menu opened
                    if (this.menuOpened) {
                        // update and emit search term
                        this.emitSearchTerm();
                    }
                }
            }
            // when delete text backward (using backspace)
            if (this.menuOpened && event.inputType === 'deleteContentBackward') {
                if (this.elementRef.nativeElement.value && this.elementRef.nativeElement.selectionEnd >= this.triggerCharPosition) {
                    // update and emit search term
                    this.emitSearchTerm();
                }
                else {
                    // close menu when no content
                    this.closeMenu();
                }
            }
        };
        NgSimpleMarkdownMentionDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.searchTermDebounceSubscription = this.searchTermDebounce
                .pipe(operators.debounce(function () { return rxjs.timer(200); }))
                .subscribe(function () {
                _this.searchTerm.emit({
                    term: _this.triggerTerm,
                    trigger: _this.triggerChar,
                });
            });
        };
        NgSimpleMarkdownMentionDirective.prototype.ngOnDestroy = function () {
            if (this.searchTermDebounceSubscription) {
                this.searchTermDebounceSubscription.unsubscribe();
            }
            // destroy previous overlay
            this.dispose();
        };
        NgSimpleMarkdownMentionDirective.prototype.ngOnChanges = function (changes) {
            // update config trigger map
            if (changes.configs && changes.configs.currentValue) {
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                var configs = changes.configs.currentValue;
                this.triggerMap = configs.reduce(function (mapping, config) {
                    var _a;
                    return (Object.assign(Object.assign({}, mapping), (_a = {}, _a[config.trigger] = config, _a)));
                }, {});
            }
            // update menu position
            if (changes.cursorPosition && changes.cursorPosition.currentValue && this.menuOpened) {
                this.updateMenuPosition();
            }
        };
        NgSimpleMarkdownMentionDirective.prototype.closeMenu = function () {
            // reset state
            this.menuOpened = false;
            this.triggerCharPosition = 0;
            this.triggerChar = '';
            this.triggerTerm = '';
            // destroy previous overlay
            this.dispose();
        };
        NgSimpleMarkdownMentionDirective.prototype.openMenu = function () {
            var _this = this;
            // destroy previous overlay
            this.dispose();
            // get config
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            var config = this.triggerMap[this.triggerChar];
            if (config) {
                // set opened
                this.menuOpened = true;
                // create overlay
                this.overlayRef = this.overlay.create({
                    positionStrategy: this.getPositionStrategy(this.cursorPosition.x + 10, this.cursorPosition.y + 20),
                });
                this.componentRef = this.overlayRef.attach(new portal.ComponentPortal(NgSimpleMarkdownMentionsComponent));
                // set input
                this.componentRef.instance.data = config.data;
                this.componentRef.instance.template = config.template;
                // subscribe to output
                this.countSubscription = this.componentRef.instance.count.subscribe(function (count) {
                    // set count
                    _this.itemCount = count;
                    // update menu position
                    _this.updateMenuPosition();
                });
                this.destroySubscription = this.componentRef.instance.destroy.subscribe(function () { return _this.closeMenu(); });
                this.selectSubscription = this.componentRef.instance.selected.subscribe(function (item) {
                    // insert content
                    _this.searchResult.emit({
                        result: config.transform ? config.transform(item) : item,
                        term: _this.triggerTerm,
                    });
                    // close menu
                    _this.closeMenu();
                });
            }
        };
        NgSimpleMarkdownMentionDirective.prototype.getPositionStrategy = function (x, y) {
            return this.overlay
                .position()
                .flexibleConnectedTo(this.elementRef.nativeElement)
                .withPositions([{
                    offsetX: x,
                    offsetY: y,
                    originX: 'start',
                    originY: 'top',
                    overlayX: 'start',
                    overlayY: 'top',
                }]);
        };
        NgSimpleMarkdownMentionDirective.prototype.updateMenuPosition = function () {
            if (this.overlayRef) {
                // determine flip upwards or downwards
                var rect = this.elementRef.nativeElement.getBoundingClientRect();
                var menuHeight = this.itemCount * 40 + 6; // with item height 40px and padding top 6px
                var menuBottom = rect.y + this.cursorPosition.y + menuHeight;
                if (window.innerHeight < menuBottom) {
                    this.overlayRef.updatePositionStrategy(this.getPositionStrategy(this.cursorPosition.x + 10, this.cursorPosition.y - menuHeight));
                }
                else {
                    this.overlayRef.updatePositionStrategy(this.getPositionStrategy(this.cursorPosition.x + 10, this.cursorPosition.y + 20));
                }
            }
        };
        NgSimpleMarkdownMentionDirective.prototype.emitSearchTerm = function () {
            if (this.elementRef && this.elementRef.nativeElement) {
                // get current value
                var value = this.elementRef.nativeElement.value || '';
                // get cursor position
                var position = this.elementRef.nativeElement.selectionEnd;
                if (this.triggerCharPosition <= position) {
                    this.triggerTerm = value.substring(this.triggerCharPosition, position);
                    this.searchTermDebounce.next();
                }
            }
        };
        NgSimpleMarkdownMentionDirective.prototype.dispose = function () {
            if (this.countSubscription) {
                this.countSubscription.unsubscribe();
                this.countSubscription = undefined;
            }
            if (this.destroySubscription) {
                this.destroySubscription.unsubscribe();
                this.destroySubscription = undefined;
            }
            if (this.selectSubscription) {
                this.selectSubscription.unsubscribe();
                this.selectSubscription = undefined;
            }
            if (this.componentRef) {
                this.componentRef.destroy();
                this.componentRef = undefined;
            }
            if (this.overlayRef) {
                this.overlayRef.dispose();
                this.overlayRef = undefined;
            }
        };
        return NgSimpleMarkdownMentionDirective;
    }());
    NgSimpleMarkdownMentionDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[ngSimpleMarkdownMention]',
                },] }
    ];
    NgSimpleMarkdownMentionDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: overlay.Overlay }
    ]; };
    NgSimpleMarkdownMentionDirective.propDecorators = {
        configs: [{ type: core.Input, args: ['ngSimpleMarkdownMention',] }],
        cursorPosition: [{ type: core.Input }],
        searchResult: [{ type: core.Output }],
        searchTerm: [{ type: core.Output }],
        onInput: [{ type: core.HostListener, args: ['input', ['$event'],] }]
    };

    var NgSimpleMarkdownEditorComponent = /** @class */ (function () {
        function NgSimpleMarkdownEditorComponent(overlay) {
            this.overlay = overlay;
            this.height = '400px';
            this.historySteps = 10;
            this.placeholder = '';
            this.resize = true;
            // for file upload
            this.files = new core.EventEmitter(true);
            this.mentionSearchTerm = new core.EventEmitter(true);
            // editor state
            this.isDisabled = false;
            this.isFullscreen = false;
            this.isWriteMode = true;
            this.screenSizeBreakpoint = 600;
            // editor model
            this.markdown = new forms.FormControl('');
            this.shadowContentUpper = '';
            this.shadowContentLower = '';
            // resize
            this.resizeOffset = 0;
            this.resizeStart = 0;
            this.resizeScrollStart = 0;
            // redo/undo state
            this.isPerformingUndoRedo = false;
            this.undoStack = [];
            this.redoStack = [];
        }
        NgSimpleMarkdownEditorComponent.prototype.keyboardEvent = function (event) {
            // get key press
            var key = (event.key || '').toLowerCase();
            // check action
            switch (key) {
                case 'escape': {
                    if (this.isFullscreen && !this.isOpenedMentionMenu) {
                        this.fullscreen();
                    }
                    break;
                }
                case 'z': {
                    if (this.historySteps > 0 && (event.ctrlKey || event.metaKey)) {
                        if (event.shiftKey) {
                            this.redo();
                        }
                        else {
                            this.undo();
                        }
                        // prevent the default undo/redo handling
                        event.preventDefault();
                        event.stopPropagation();
                    }
                    break;
                }
                case 'arrowdown': /* cspell: disable-line */
                case 'arrowleft': /* cspell: disable-line */
                case 'arrowright': /* cspell: disable-line */
                case 'arrowup': { /* cspell: disable-line */
                    // update cursor
                    this.updateCursor();
                    break;
                }
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.ngOnInit = function () {
            var _this = this;
            // set up resizing functions to global scope
            window['editorResizing'] = function (e) {
                _this.onResizing(e);
            };
            window['editorResizeEnd'] = function () {
                _this.onResizeEnd();
            };
            // watch for control value change
            this.controlSubscription = this.markdown.valueChanges
                .pipe(operators.debounce(function () { return rxjs.timer(200); }))
                .subscribe(function (value) {
                // save history
                if (_this.historySteps > 0) {
                    if (!_this.isPerformingUndoRedo) {
                        _this.saveUndo();
                    }
                    // reset state
                    _this.isPerformingUndoRedo = false;
                }
                // trigger changes
                if (_this.fnOnChange) {
                    _this.fnOnChange(value);
                }
                if (_this.fnOnTouched) {
                    _this.fnOnTouched();
                }
            });
        };
        NgSimpleMarkdownEditorComponent.prototype.ngOnDestroy = function () {
            if (this.controlSubscription) {
                this.controlSubscription.unsubscribe();
            }
            if (this.fullScreenControlSubscription) {
                this.fullScreenControlSubscription.unsubscribe();
            }
        };
        Object.defineProperty(NgSimpleMarkdownEditorComponent.prototype, "isMobile", {
            get: function () {
                return window.innerWidth < this.screenSizeBreakpoint;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgSimpleMarkdownEditorComponent.prototype, "editorHeight", {
            get: function () {
                var toolbarHeight = this.isMobile ? 81 : 41;
                var borderSizeAdjust = 2;
                return parseInt(this.height, 10) + this.resizeOffset - toolbarHeight - borderSizeAdjust + "px";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgSimpleMarkdownEditorComponent.prototype, "isInFullscreen", {
            get: function () {
                return !!this.fullScreenComponentRef && !!this.fullScreenComponentRef.instance;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgSimpleMarkdownEditorComponent.prototype, "isOpenedMentionMenu", {
            get: function () {
                return this.mentionDirective.menuOpened;
            },
            enumerable: false,
            configurable: true
        });
        NgSimpleMarkdownEditorComponent.prototype.writeValue = function (markdown) {
            if (markdown !== null && markdown !== undefined) {
                this.markdown.setValue(markdown);
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.registerOnChange = function (fn) {
            this.fnOnChange = fn;
        };
        NgSimpleMarkdownEditorComponent.prototype.registerOnTouched = function (fn) {
            this.fnOnTouched = fn;
        };
        NgSimpleMarkdownEditorComponent.prototype.setDisabledState = function (isDisabled) {
            if (isDisabled) {
                this.markdown.disable();
            }
            this.isDisabled = isDisabled;
        };
        NgSimpleMarkdownEditorComponent.prototype.onDrop = function (event) {
            if (event.dataTransfer.files.length > 0) {
                this.files.emit(Array.from(event.dataTransfer.files));
                event.stopPropagation();
                event.preventDefault();
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.onPaste = function (event) {
            if (event.clipboardData.files.length > 0) {
                event.stopPropagation();
                event.preventDefault();
                this.files.emit(Array.from(event.clipboardData.files));
            }
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.onInput = function () {
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.onResizeStart = function (event) {
            if (this.resize && this.isWriteMode) {
                if (this.resizeStart === 0) {
                    this.resizeStart = event.clientY;
                }
                if (this.resizeScrollStart === 0) {
                    var rect = this.editingContainerElement.nativeElement.getBoundingClientRect();
                    this.resizeScrollStart = rect.y;
                }
                document.documentElement.addEventListener('mousemove', window['editorResizing'], false);
                document.documentElement.addEventListener('mouseup', window['editorResizeEnd'], false);
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.onResizing = function (event) {
            var rect = this.editingContainerElement.nativeElement.getBoundingClientRect();
            this.resizeOffset = event.clientY + (this.resizeScrollStart - rect.y) - this.resizeStart;
            if (this.resizeOffset < 0) {
                this.resizeOffset = 0;
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.onResizeEnd = function () {
            document.documentElement.removeEventListener('mousemove', window['editorResizing'], false);
            document.documentElement.removeEventListener('mouseup', window['editorResizeEnd'], false);
        };
        NgSimpleMarkdownEditorComponent.prototype.onEditorScroll = function (event) {
            this.shadowEditorElement.nativeElement.scrollTop = event.target.scrollTop;
        };
        NgSimpleMarkdownEditorComponent.prototype.updateCursor = function () {
            var _this = this;
            setTimeout(function () {
                // get selection range
                var position = _this.textareaElement.nativeElement.selectionEnd;
                // markdown value
                var value = _this.markdown.value;
                // set content
                _this.shadowContentUpper = value.substring(0, position);
                _this.shadowContentLower = value.substring(position);
                // update cursor position
                _this.cursorPosition = {
                    x: _this.shadowCursorElement.nativeElement.offsetLeft,
                    y: _this.shadowCursorElement.nativeElement.offsetTop,
                };
            });
        };
        NgSimpleMarkdownEditorComponent.prototype.fullscreen = function () {
            var _this = this;
            // close all mention menu
            this.mentionDirective.closeMenu();
            if (this.isFullscreen) {
                // exit full screen
                if (this.fullScreenControlSubscription) {
                    this.fullScreenControlSubscription.unsubscribe();
                }
                if (this.fullScreenComponentRef) {
                    this.fullScreenComponentRef.destroy();
                }
                if (this.fullScreenOverlayRef) {
                    this.fullScreenOverlayRef.dispose();
                }
            }
            else {
                // create overlay
                this.fullScreenOverlayRef = this.overlay.create();
                this.fullScreenComponentRef = this.fullScreenOverlayRef.attach(new portal.ComponentPortal(NgSimpleMarkdownEditorComponent));
                this.fullScreenComponentRef.onDestroy(function () {
                    // set editor selection
                    _this.textareaElement.nativeElement.setSelectionRange(_this.fullScreenComponentRef.instance.textareaElement.nativeElement.selectionStart, _this.fullScreenComponentRef.instance.textareaElement.nativeElement.selectionEnd);
                    // update cursor
                    _this.updateCursor();
                    // unset component reference
                    _this.fullScreenComponentRef = undefined;
                });
                // set input
                this.fullScreenComponentRef.instance.height = this.height;
                this.fullScreenComponentRef.instance.historySteps = this.historySteps;
                this.fullScreenComponentRef.instance.placeholder = this.placeholder;
                this.fullScreenComponentRef.instance.resize = this.resize;
                // for file upload
                this.fullScreenComponentRef.instance.files = this.files;
                // for mentions
                this.fullScreenComponentRef.instance.mentionConfigs = this.mentionConfigs;
                this.fullScreenComponentRef.instance.mentionSearchTerm = this.mentionSearchTerm;
                // editor state
                this.fullScreenComponentRef.instance.isDisabled = this.isDisabled;
                this.fullScreenComponentRef.instance.isFullscreen = true;
                this.fullScreenComponentRef.instance.isWriteMode = this.isWriteMode;
                this.fullScreenComponentRef.instance.cursorPosition = this.cursorPosition;
                this.fullScreenComponentRef.instance.screenSizeBreakpoint = this.screenSizeBreakpoint;
                // editor model
                this.fullScreenComponentRef.instance.markdown.setValue(this.markdown.value);
                this.fullScreenComponentRef.instance.shadowContentUpper = this.shadowContentUpper;
                this.fullScreenComponentRef.instance.shadowContentLower = this.shadowContentLower;
                // redo/undo state
                this.fullScreenComponentRef.instance.isPerformingUndoRedo = this.isPerformingUndoRedo;
                this.fullScreenComponentRef.instance.undoStack = this.undoStack;
                this.fullScreenComponentRef.instance.redoStack = this.redoStack;
                // full screen
                this.fullScreenComponentRef.instance.fullScreenOverlayRef = this.fullScreenOverlayRef;
                // this.fullScreenComponentRef.instance.fullScreenComponentRef = this.fullScreenComponentRef; <<-- don't un-comment this
                setTimeout(function () {
                    // set editor selection
                    _this.fullScreenComponentRef.instance.textareaElement.nativeElement.setSelectionRange(_this.textareaElement.nativeElement.selectionStart, _this.textareaElement.nativeElement.selectionEnd);
                    // update cursor
                    _this.fullScreenComponentRef.instance.updateCursor();
                });
                // pipe overlay markdown
                this.fullScreenControlSubscription = this.fullScreenComponentRef.instance.markdown.valueChanges
                    .pipe(operators.debounce(function () { return rxjs.timer(50); }))
                    .subscribe(function (value) {
                    // set value
                    _this.markdown.setValue(value);
                    // trigger changes
                    if (_this.fnOnChange) {
                        _this.fnOnChange(value);
                    }
                    if (_this.fnOnTouched) {
                        _this.fnOnTouched();
                    }
                });
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.onSearchResult = function (result) {
            this.insertContent(result.result, result.term.length);
        };
        NgSimpleMarkdownEditorComponent.prototype.onSearchTerm = function (term) {
            this.mentionSearchTerm.emit(term);
        };
        // formatting function
        NgSimpleMarkdownEditorComponent.prototype.insertLink = function () {
            // get url
            var description = prompt('Enter url text');
            var url = prompt('Enter url');
            if (url) {
                // construct string
                this.insertContent("[" + description + "](" + url + ")");
                // save history
                this.saveUndo();
                // update cursor
                this.updateCursor();
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.insertPhoto = function () {
            // get image url
            var description = prompt('Enter image description (optional)');
            var url = prompt('Enter image url');
            if (url) {
                // construct string
                this.insertContent("![" + description + "](" + url + ")");
                // save history
                this.saveUndo();
                // update cursor
                this.updateCursor();
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.bold = function () {
            // get selection range
            var start = this.textareaElement.nativeElement.selectionStart;
            var end = this.textareaElement.nativeElement.selectionEnd;
            // markdown value
            var value = this.markdown.value;
            // construct string
            var result = ''.concat(value.substring(0, start), "**" + value.substring(start, end) + "**", value.substr(end));
            // update editor
            this.markdown.setValue(result);
            // save history
            this.saveUndo();
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.italic = function () {
            // get selection range
            var start = this.textareaElement.nativeElement.selectionStart;
            var end = this.textareaElement.nativeElement.selectionEnd;
            // markdown value
            var value = this.markdown.value;
            // construct string
            var result = ''.concat(value.substring(0, start), "*" + value.substring(start, end) + "*", value.substr(end));
            // update editor
            this.markdown.setValue(result);
            // save history
            this.saveUndo();
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.quote = function () {
            // get selection range
            var start = this.textareaElement.nativeElement.selectionStart;
            var end = this.textareaElement.nativeElement.selectionEnd;
            // markdown value
            var value = this.markdown.value;
            // manipulate strings
            var lines = value.substring(start, end).split('\n');
            var modifiedString = start === end ? ['> '] : lines.reduce(function (resultLines, line) { return __spread(resultLines, [
                "> " + line,
            ]); }, []);
            // construct string
            var result = ''.concat(value.substring(0, start), modifiedString.join('\n'), value.substr(end));
            // update editor
            this.markdown.setValue(result);
            // save history
            this.saveUndo();
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.code = function () {
            // get selection range
            var start = this.textareaElement.nativeElement.selectionStart;
            var end = this.textareaElement.nativeElement.selectionEnd;
            // markdown value
            var value = this.markdown.value;
            // construct string
            var result = ''.concat(value.substring(0, start), "```\n" + value.substring(start, end) + "\n```", value.substr(end));
            // update editor
            this.markdown.setValue(result);
            // save history
            this.saveUndo();
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.bulletedList = function () {
            // get selection range
            var start = this.textareaElement.nativeElement.selectionStart;
            var end = this.textareaElement.nativeElement.selectionEnd;
            // markdown value
            var value = this.markdown.value;
            // manipulate strings
            var lines = value.substring(start, end).split('\n');
            var modifiedString = start === end ? ['* '] : lines.reduce(function (resultLines, line) { return __spread(resultLines, [
                "* " + line,
            ]); }, []);
            // construct string
            var result = ''.concat(value.substring(0, start), modifiedString.join('\n'), value.substr(end));
            // update editor
            this.markdown.setValue(result);
            // save history
            this.saveUndo();
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.numberedList = function () {
            // get selection range
            var start = this.textareaElement.nativeElement.selectionStart;
            var end = this.textareaElement.nativeElement.selectionEnd;
            // markdown value
            var value = this.markdown.value;
            // manipulate strings
            var lines = value.substring(start, end).split('\n');
            var modifiedString = start === end ? ['1. '] : lines.reduce(function (resultLines, line, index) { return __spread(resultLines, [
                index + 1 + ". " + line,
            ]); }, []);
            // construct string
            var result = ''.concat(value.substring(0, start), modifiedString.join('\n'), value.substr(end));
            // update editor
            this.markdown.setValue(result);
            // save history
            this.saveUndo();
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.taskList = function () {
            // get selection range
            var start = this.textareaElement.nativeElement.selectionStart;
            var end = this.textareaElement.nativeElement.selectionEnd;
            // markdown value
            var value = this.markdown.value;
            // manipulate strings
            var lines = value.substring(start, end).split('\n');
            var modifiedString = start === end ? ['- [ ] '] : lines.reduce(function (resultLines, line) { return __spread(resultLines, [
                "- [ ] " + line,
            ]); }, []);
            // construct string
            var result = ''.concat(value.substring(0, start), modifiedString.join('\n'), value.substr(end));
            // update editor
            this.markdown.setValue(result);
            // save history
            this.saveUndo();
            // update cursor
            this.updateCursor();
        };
        NgSimpleMarkdownEditorComponent.prototype.insertContent = function (content, skipBackwardLength) {
            if (skipBackwardLength === void 0) { skipBackwardLength = 0; }
            // insert to fullscreen editor
            if (this.isInFullscreen) {
                return this.fullScreenComponentRef.instance.insertContent(content, skipBackwardLength);
            }
            // insert to this editor
            if (this.textareaElement) {
                // get selection range
                var start = this.textareaElement.nativeElement.selectionStart;
                var end = this.textareaElement.nativeElement.selectionEnd;
                // markdown value
                var value = this.markdown.value;
                // construct string
                var result = ''.concat(value.substring(0, start - skipBackwardLength), content, value.substr(end));
                // update editor
                this.markdown.setValue(result);
                // save history
                this.saveUndo();
                // get new cursor position
                var position = start - skipBackwardLength + content.length;
                // update selection range
                this.textareaElement.nativeElement.setSelectionRange(position, position);
                // update cursor
                this.updateCursor();
            }
            return content.length;
        };
        // editor history
        NgSimpleMarkdownEditorComponent.prototype.saveUndo = function () {
            if (this.textareaElement && this.historySteps > 0) {
                // save editor state
                this.undoStack.unshift(new EditorHistory(this.markdown.value, this.textareaElement.nativeElement.selectionStart, this.textareaElement.nativeElement.selectionEnd));
                if (this.undoStack.length > this.historySteps) {
                    for (var i = 0; i < this.undoStack.length - this.historySteps; i++) {
                        this.undoStack.pop();
                    }
                }
                // clear redo stack
                this.redoStack = [];
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.undo = function () {
            if (this.textareaElement && this.historySteps > 0 && this.undoStack.length > 0) {
                // move the first element from undo to redo
                this.redoStack.unshift(this.undoStack.shift());
                // restore editor state
                var _a = __read(this.undoStack, 1), current = _a[0];
                if (current) {
                    this.isPerformingUndoRedo = true;
                    this.markdown.setValue(current.content || '');
                    this.textareaElement.nativeElement.setSelectionRange(current.selectionStart, current.selectionEnd);
                    this.updateCursor();
                }
            }
        };
        NgSimpleMarkdownEditorComponent.prototype.redo = function () {
            if (this.textareaElement && this.historySteps > 0 && this.redoStack.length > 0) {
                // move the first element from redo to undo
                this.undoStack.unshift(this.redoStack.shift());
                // restore editor state
                var _a = __read(this.undoStack, 1), current = _a[0];
                if (current) {
                    this.isPerformingUndoRedo = true;
                    this.markdown.setValue(current.content || '');
                    this.textareaElement.nativeElement.setSelectionRange(current.selectionStart, current.selectionEnd);
                    this.updateCursor();
                }
            }
        };
        return NgSimpleMarkdownEditorComponent;
    }());
    NgSimpleMarkdownEditorComponent.decorators = [
        { type: core.Component, args: [{
                    providers: [
                        {
                            multi: true,
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return NgSimpleMarkdownEditorComponent; }),
                        },
                    ],
                    selector: 'ng-simple-markdown-editor',
                    template: "<div class=\"ng-simple-markdown-editor\" [class.ng-simple-markdown-editor--fullscreen]=\"isFullscreen\">\n\n\t<div class=\"ng-simple-markdown-editor__toolbar\">\n\n\t\t<div class=\"ng-simple-markdown-editor__view-mode\">\n\t\t\t<button mat-button [disabled]=\"isDisabled\" [color]=\"isWriteMode ? 'primary' : ''\" (click)=\"isWriteMode = true\">Write</button>\n\t\t\t<button mat-button [disabled]=\"isDisabled\" [color]=\"isWriteMode ? '' : 'primary'\" (click)=\"isWriteMode = false\">Preview</button>\n\t\t</div>\n\n\t\t<div class=\"ng-simple-markdown-editor__spacer\"></div>\n\n\t\t<div class=\"ng-simple-markdown-editor__format\" *ngIf=\"isWriteMode\">\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"insertLink()\"><mat-icon>link</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"insertPhoto()\"><mat-icon>insert_photo</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"bold()\"><mat-icon>format_bold</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"italic()\"><mat-icon>format_italic</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"quote()\"><mat-icon>format_quote</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"code()\"><mat-icon>code</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"bulletedList()\"><mat-icon>format_list_bulleted</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"numberedList()\"><mat-icon>format_list_numbered</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"taskList()\"><mat-icon>assignment_turned_in</mat-icon></button>\n\t\t\t<button mat-icon-button [disabled]=\"isDisabled\" (click)=\"fullscreen()\"><mat-icon>fullscreen</mat-icon></button>\n\t\t</div>\n\n\t</div>\n\n\t<div #editingContainerElement class=\"ng-simple-markdown-editor__editing\" [style.height]=\"editorHeight\">\n\n\t\t<ng-container *ngIf=\"isWriteMode; then editorView; else previewView\"></ng-container>\n\n\t\t<ng-template #editorView>\n\t\t\t<textarea #textareaElement\n\t\t\t\t(click)=\"updateCursor()\"\n\t\t\t\t(drop)=\"onDrop($event)\"\n\t\t\t\t(input)=\"onInput()\"\n\t\t\t\t(paste)=\"onPaste($event)\"\n\t\t\t\t(scroll)=\"onEditorScroll($event)\"\n\t\t\t\t(searchResult)=\"onSearchResult($event)\"\n\t\t\t\t(searchTerm)=\"onSearchTerm($event)\"\n\t\t\t\t[cursorPosition]=\"cursorPosition\"\n\t\t\t\t[formControl]=\"markdown\"\n\t\t\t\t[ngSimpleMarkdownMention]=\"mentionConfigs\"\n\t\t\t\t[placeholder]=\"placeholder\"\n\t\t\t></textarea>\n\t\t\t<pre #shadowEditorElement>{{shadowContentUpper}}<span class=\"cursor\" #shadowCursorElement></span>{{shadowContentLower}}</pre>\n\t\t</ng-template>\n\n\t\t<ng-template #previewView>\n\t\t\t<iframe ngSimpleMarkdownViewer [markdown]=\"markdown.value\"></iframe>\n\t\t</ng-template>\n\n\t</div>\n\n</div>\n<div *ngIf=\"resize && isWriteMode\" class=\"resize-handle\" (mousedown)=\"onResizeStart($event)\"></div>\n",
                    styles: [".ng-simple-markdown-editor{align-items:stretch;background-color:#fff;border:1px solid #ccc;display:flex;flex-direction:column;height:100%;justify-content:flex-start}.ng-simple-markdown-editor--fullscreen{bottom:0!important;left:0!important;margin:0!important;position:fixed!important;right:0!important;top:0!important;z-index:9999!important}.ng-simple-markdown-editor__toolbar{align-items:stretch;border-bottom:1px solid #ccc;display:flex;justify-content:flex-start;padding:0 2px}@media (min-width:600px){.ng-simple-markdown-editor__toolbar{flex-direction:row;height:40px}}@media (max-width:600px){.ng-simple-markdown-editor__toolbar{flex-direction:column;height:80px}}.ng-simple-markdown-editor__spacer{flex:1 1 auto}@media (max-width:600px){.ng-simple-markdown-editor__spacer{display:none}}.ng-simple-markdown-editor__view-mode{display:flex;flex-direction:row;height:40px}@media (min-width:600px){.ng-simple-markdown-editor__view-mode{align-items:center;justify-content:flex-start}}@media (max-width:600px){.ng-simple-markdown-editor__view-mode{align-items:center;justify-content:space-evenly}}.ng-simple-markdown-editor__format{display:flex;flex-direction:row;height:40px;justify-content:flex-start}@media (min-width:600px){.ng-simple-markdown-editor__format{align-items:center}}@media (max-width:600px){.ng-simple-markdown-editor__format{-webkit-overflow-scrolling:touch;align-items:center;overflow-x:auto}}.ng-simple-markdown-editor__editing{align-items:flex-start;display:flex;flex:1 1 auto;flex-direction:row;justify-content:flex-start;overflow:auto;position:relative}.ng-simple-markdown-editor__editing iframe{-o-object-fit:contain;-o-object-position:center center;border:none;object-fit:contain;object-position:center center;padding:10px;width:calc(100% - 20px)!important}.ng-simple-markdown-editor__editing pre,.ng-simple-markdown-editor__editing textarea{border:none;bottom:0;font-family:Lucida Console,Monaco,monospace;font-size:14px;height:calc(100% - 20px)!important;left:0;line-height:1.4;margin:0;overflow-y:auto;padding:10px;position:absolute;resize:none;right:0;top:0;white-space:-moz-pre-wrap;white-space:-o-pre-wrap;white-space:pre-wrap;width:calc(100% - 20px)!important;word-wrap:break-word}.ng-simple-markdown-editor__editing pre:active,.ng-simple-markdown-editor__editing pre:focus,.ng-simple-markdown-editor__editing textarea:active,.ng-simple-markdown-editor__editing textarea:focus{-moz-appearance:none;-webkit-appearance:none;appearance:none;outline:0}.ng-simple-markdown-editor__editing pre{color:transparent;pointer-events:none}.ng-simple-markdown-editor__editing pre .cursor{border:1px solid transparent}.resize-handle{background-color:#ccc;cursor:row-resize;height:2px;width:100%}"]
                },] }
    ];
    NgSimpleMarkdownEditorComponent.ctorParameters = function () { return [
        { type: overlay.Overlay }
    ]; };
    NgSimpleMarkdownEditorComponent.propDecorators = {
        editingContainerElement: [{ type: core.ViewChild, args: ['editingContainerElement',] }],
        shadowCursorElement: [{ type: core.ViewChild, args: ['shadowCursorElement',] }],
        shadowEditorElement: [{ type: core.ViewChild, args: ['shadowEditorElement',] }],
        textareaElement: [{ type: core.ViewChild, args: ['textareaElement',] }],
        mentionDirective: [{ type: core.ViewChild, args: [NgSimpleMarkdownMentionDirective,] }],
        height: [{ type: core.Input }],
        historySteps: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        resize: [{ type: core.Input }],
        files: [{ type: core.Output }],
        mentionConfigs: [{ type: core.Input }],
        mentionSearchTerm: [{ type: core.Output }],
        keyboardEvent: [{ type: core.HostListener, args: ['document:keydown', ['$event'],] }]
    };

    var MarkdownItHashTag = function (md) {
        var parserId = 'hash-tag';
        var parser = function (state, silent) {
            // get parser input
            var matches = new RegExp(/#\w+/).exec(state.src.slice(state.pos));
            if (
            // if nothing match
            !matches ||
                // check if matched string is start of input
                (matches.index > 0 &&
                    matches.input[matches.index - 1]) ||
                // if not separated by space or start of line
                (state.pos > 0 &&
                    state.src[state.pos - 1] !== ' ' &&
                    state.src[state.pos - 1] !== '\n')) {
                return false;
            }
            // advance the cursor
            state.pos += matches[0].length;
            // no token in silent mode
            if (silent) {
                return true;
            }
            // generate token
            var token = state.push(parserId, '', 0);
            token.meta = { matches: matches };
            return true;
        };
        var render = function (tokens, id) {
            // get matches
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            var matches = tokens[id].meta.matches;
            var tag = matches[0];
            // render result
            return "<a href=\"#\" data-mention-tag=\"" + tag + "\">" + tag + "</a>";
        };
        // register parser & render
        md.inline.ruler.push(parserId, parser);
        md.renderer.rules[parserId] = render;
    };

    var MarkdownItMentionWithId = function (md) {
        var parserId = 'mention-with-id';
        var parser = function (state, silent) {
            // get parser input
            var matches = new RegExp(/@\(([0-9a-f-]+)\|([\w.\-_]+)\)/i).exec(state.src.slice(state.pos));
            if (
            // if nothing match
            !matches ||
                // check if matched string is start of input
                (matches.index > 0 &&
                    matches.input[matches.index - 1]) ||
                // if not separated by space or start of line
                (state.pos > 0 &&
                    state.src[state.pos - 1] !== ' ' &&
                    state.src[state.pos - 1] !== '\n')) {
                return false;
            }
            // advance the cursor
            state.pos += matches[0].length;
            // no token in silent mode
            if (silent) {
                return true;
            }
            // generate token
            var token = state.push(parserId, '', 0);
            token.meta = { matches: matches };
            return true;
        };
        var render = function (tokens, id) {
            // get matches
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            var matches = tokens[id].meta.matches;
            // get matched mention
            var userId = matches[1];
            var name = matches[2];
            // render result
            return "<a href=\"#\" data-mention-id=\"" + userId + "\" data-mention-name=\"" + name + "\">" + ("@" + name) + "</a>";
        };
        // register parser & render
        md.inline.ruler.push(parserId, parser);
        md.renderer.rules[parserId] = render;
    };

    var MarkdownItMentions = function (md) {
        var parserId = 'mention';
        var parser = function (state, silent) {
            // get parser input
            var matches = new RegExp(/@([\w.\-_]+)/i).exec(state.src.slice(state.pos));
            if (
            // if nothing match
            !matches ||
                // check if matched string is start of input
                (matches.index > 0 &&
                    matches.input[matches.index - 1]) ||
                // if not separated by space or start of line
                (state.pos > 0 &&
                    state.src[state.pos - 1] !== ' ' &&
                    state.src[state.pos - 1] !== '\n')) {
                return false;
            }
            // advance the cursor
            state.pos += matches[0].length;
            // no token in silent mode
            if (silent) {
                return true;
            }
            // generate token
            var token = state.push(parserId, '', 0);
            token.meta = { matches: matches };
            return true;
        };
        var render = function (tokens, id) {
            // get matches
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            var matches = tokens[id].meta.matches;
            // get matched mention
            var name = matches[1];
            // render result
            return "<a href=\"#\" data-mention-name=\"" + name + "\">" + ("@" + name) + "</a>";
        };
        // register parser & render
        md.inline.ruler.push(parserId, parser);
        md.renderer.rules[parserId] = render;
    };

    var MarkdownItTitle = function (md) {
        var parserId = 'title';
        var parser = function (state, silent) {
            // get parser input
            var matches = new RegExp(/\{(.+)\|\|(.+)\}/).exec(state.src.slice(state.pos));
            if (
            // if nothing match
            !matches ||
                // check if matched string is start of input
                (matches.index > 0 &&
                    matches.input[matches.index - 1])) {
                return false;
            }
            // advance the cursor
            state.pos += matches[0].length;
            // no token in silent mode
            if (silent) {
                return true;
            }
            // generate token
            var token = state.push(parserId, '', 0);
            token.meta = { matches: matches };
            return true;
        };
        var render = function (tokens, id) {
            // get matches
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            var matches = tokens[id].meta.matches;
            // get matched mention
            var text = matches[1];
            var title = matches[2];
            // render result
            return "<span title=\"" + title + "\">" + text + "</a>";
        };
        // register parser & render
        md.inline.ruler.push(parserId, parser);
        md.renderer.rules[parserId] = render;
    };

    var NgSimpleMarkdownService = /** @class */ (function () {
        function NgSimpleMarkdownService() {
            // init instance
            this.markdownIt = new MarkdownIt({
                breaks: true,
                linkify: true,
            });
            // use plugins
            this.markdownIt.use(MarkdownItHashTag);
            this.markdownIt.use(MarkdownItMentions);
            this.markdownIt.use(MarkdownItMentionWithId);
            this.markdownIt.use(MarkdownItTitle);
            this.markdownIt.use(TaskList, { enabled: true });
        }
        NgSimpleMarkdownService.prototype.parse = function (markdown) {
            return this.markdownIt.render(markdown);
        };
        return NgSimpleMarkdownService;
    }());
    NgSimpleMarkdownService.decorators = [
        { type: core.Injectable }
    ];
    NgSimpleMarkdownService.ctorParameters = function () { return []; };

    var NgSimpleMarkdownTextPreviewPipe = /** @class */ (function () {
        function NgSimpleMarkdownTextPreviewPipe(ngSimpleMarkdownService) {
            this.ngSimpleMarkdownService = ngSimpleMarkdownService;
        }
        NgSimpleMarkdownTextPreviewPipe.prototype.transform = function (markdown) {
            if (markdown) {
                var html = this.ngSimpleMarkdownService.parse(markdown);
                var placeholder = document.createElement('div');
                placeholder.innerHTML = this.filterHTML(html);
                return placeholder.textContent;
            }
            return '';
        };
        NgSimpleMarkdownTextPreviewPipe.prototype.filterHTML = function (html) {
            var e_1, _a;
            var dom = (new DOMParser()).parseFromString(html, 'text/html');
            // remove images
            var imgTags = Array.from(dom.querySelectorAll('img'));
            try {
                for (var imgTags_1 = __values(imgTags), imgTags_1_1 = imgTags_1.next(); !imgTags_1_1.done; imgTags_1_1 = imgTags_1.next()) {
                    var imgTag = imgTags_1_1.value;
                    imgTag.remove();
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (imgTags_1_1 && !imgTags_1_1.done && (_a = imgTags_1.return)) _a.call(imgTags_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return (new XMLSerializer()).serializeToString(dom);
        };
        return NgSimpleMarkdownTextPreviewPipe;
    }());
    NgSimpleMarkdownTextPreviewPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'ngSimpleMarkdownTextPreview',
                },] }
    ];
    NgSimpleMarkdownTextPreviewPipe.ctorParameters = function () { return [
        { type: NgSimpleMarkdownService }
    ]; };

    var NgSimpleMarkdownViewerDirective = /** @class */ (function () {
        function NgSimpleMarkdownViewerDirective(elementRef, ngSimpleMarkdownService, sanitizer) {
            this.elementRef = elementRef;
            this.ngSimpleMarkdownService = ngSimpleMarkdownService;
            this.sanitizer = sanitizer;
            this.mentions = new core.EventEmitter(true);
            this.mentionWithIds = new core.EventEmitter(true);
            this.ready = new core.EventEmitter(true);
            this.tags = new core.EventEmitter(true);
            this.taskLists = new core.EventEmitter(true);
            this.border = 'none';
            this.iframeHeight = '0px';
            this.iframeWidth = '0px';
            this.iframeStyle = "\n\t\t<style type=\"text/css\">\n\t\tbody {\n\t\t\tfont-family: Roboto, \"Helvetica Neue\", sans-serif; /* cspell: disable-line */\n\t\t\tmargin: 0;\n\t\t\tword-wrap: break-word;\n\t\t}\n\t\ta {\n\t\t\tborder-radius: 0;\n\t\t\tcolor: #337ab7;\n\t\t\tfont-weight: normal;\n\t\t\ttext-decoration: none;\n\t\t\twidth: 100%;\n\t\t\tword-wrap: break-all;\n\t\t}\n\t\ta:focus, a:hover {\n\t\t\tbackground-color: transparent;\n\t\t\tcolor: #23527c;\n\t\t\ttext-decoration: underline;\n\t\t}\n\t\tblockquote {\n\t\t\tborder-left: 5px #cccccc solid;\n\t\t\tmargin: 13px 40px;\n\t\t\tpadding: 2px 8px 2px 20px;\n\t\t}\n\t\tcode {\n\t\t\tbackground-color: #fcedea;\n\t\t\tborder-radius: 3px;\n\t\t\tcolor: #c0341d;\n\t\t\tfont-size: 90%;\n\t\t\tpadding: 2px 4px;\n\t\t}\n\t\tpre {\n\t\t\tborder-radius: 2px;\n\t\t\tborder: 1px solid #e5e5e5;\n\t\t\tdisplay: block;\n\t\t\tline-height: 1.6em;\n\t\t\tmargin: 16px 4px;\n\t\t\toverflow-x: auto;\n\t\t\tpadding: 10px;\n\t\t\tword-break: break-all;\n\t\t\tword-wrap: break-word;\n\t\t}\n\t\tpre code {\n\t\t\tbackground-color: transparent;\n\t\t\tcolor: #333;\n\t\t}\n\t\ttable {\n\t\t\tborder-collapse: collapse;\n\t\t\tborder-spacing: 0;\n\t\t\tborder: 1px solid #ddd;\n\t\t\tmargin: 5px;\n\t\t}\n\t\ttable tr:nth-child(even) {\n\t\t\tbackground-color: #efefef;\n\t\t}\n\t\ttable th {\n\t\t\tborder: 1px solid #ddd;\n\t\t\tfont-weight: bold;\n\t\t\tpadding: 10px;\n\t\t}\n\t\ttable td {\n\t\t\tborder: 1px solid #ddd;\n\t\t\tpadding: 10px;\n\t\t}\n\t\th1, h2, h3, h4, h5 {\n\t\t\tline-height: 1;\n\t\t}\n\t\timg {\n\t\t\tborder: 1px #e0e0e0 solid;\n\t\t\tdisplay: block;\n\t\t\theight: auto;\n\t\t\tmax-width: calc(100% - 10px);\n\t\t\tpadding: 4px;\n\t\t}\n\t\tp {\n\t\t\tmargin: 0;\n\t\t}\n\t\tp + p {\n\t\t\tpadding-top: 16px;\n\t\t}\n\t\t.contains-task-list {\n\t\t\tlist-style: none;\n\t\t\tpadding-left: 20px;\n\t\t}\n\t\t</style>\n\t";
        }
        NgSimpleMarkdownViewerDirective.prototype.getContentDocument = function () {
            if (!this.iframeDocument) {
                // get iframe html element
                var iframeElement = this.elementRef.nativeElement;
                // get content document
                this.iframeDocument = iframeElement.contentWindow.document || iframeElement.contentDocument;
            }
            return this.iframeDocument;
        };
        NgSimpleMarkdownViewerDirective.prototype.onLoad = function () {
            return __awaiter(this, void 0, void 0, function () {
                var mentions, hashTags, taskListItems;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: 
                        // update height
                        return [4 /*yield*/, this.updateSize()];
                        case 1:
                            // update height
                            _a.sent();
                            mentions = this.getContentDocument().querySelectorAll('[data-mention-name]');
                            if (mentions.length > 0) {
                                mentions.forEach(function (mention) {
                                    mention.addEventListener('click', function (event) {
                                        var id = mention.dataset.mentionId;
                                        var name = mention.dataset.mentionName;
                                        if (id) {
                                            _this.mentionWithIds.emit([id, name]);
                                        }
                                        else {
                                            _this.mentions.emit(name);
                                        }
                                        event.preventDefault();
                                        event.stopPropagation();
                                    });
                                });
                            }
                            hashTags = this.getContentDocument().querySelectorAll('[data-mention-tag]');
                            if (hashTags.length > 0) {
                                hashTags.forEach(function (hashTag) {
                                    hashTag.addEventListener('click', function (event) {
                                        _this.tags.emit(hashTag.dataset.mentionTag);
                                        event.preventDefault();
                                        event.stopPropagation();
                                    });
                                });
                            }
                            taskListItems = this.getContentDocument().querySelectorAll('.task-list-item-checkbox');
                            if (taskListItems.length > 0) {
                                taskListItems.forEach(function (taskListItem, index) {
                                    taskListItem.addEventListener('click', function (event) {
                                        if (_this.markdown) {
                                            var normalized_1 = ['* [ ] ', '* [x] ', '- [x] '].reduce(function (str, deli) { return str.split(deli).join('- [ ] '); }, _this.markdown);
                                            var position = new Array(index).fill(0).reduce(function (pos) { return normalized_1.indexOf('- [ ] ', pos + 1); }, normalized_1.indexOf('- [ ] '));
                                            var result = _this.markdown.substring(0, position + 3)
                                                + (_this.markdown.charAt(position + 3) === ' ' ? 'x' : ' ')
                                                + _this.markdown.substring(position + 4);
                                            _this.taskLists.emit(result);
                                        }
                                        event.preventDefault();
                                        event.stopPropagation();
                                    });
                                });
                            }
                            // notify done
                            this.ready.emit(true);
                            return [2 /*return*/];
                    }
                });
            });
        };
        NgSimpleMarkdownViewerDirective.prototype.ngOnChanges = function (changes) {
            // when new email bind then re-paint iframe content
            if (changes.markdown) {
                // notify loading
                this.ready.emit(false);
                // additional styles
                var additionalStyles = this.styles ? "<style type=\"text/css\">" + this.styles + "</style>" : '';
                // parse markdown
                var html = this.iframeStyle + additionalStyles + this.ngSimpleMarkdownService.parse(changes.markdown.currentValue);
                // bypass html security check
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                var secureHTML = this.sanitizer.bypassSecurityTrustHtml(html);
                // filter html content
                // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
                var filteredHTML = this.filterHTML(secureHTML.changingThisBreaksApplicationSecurity);
                // write html
                this.getContentDocument().open();
                this.getContentDocument().write(filteredHTML);
                this.getContentDocument().close();
            }
        };
        NgSimpleMarkdownViewerDirective.prototype.updateSize = function () {
            var _this = this;
            return new Promise(function (resolve) {
                // set height
                setTimeout(function () {
                    // get height
                    var htmlHeight = _this.getContentDocument().querySelector('html').scrollHeight;
                    var bodyHeight = _this.getContentDocument().querySelector('body').scrollHeight;
                    // get width
                    var htmlWidth = _this.getContentDocument().querySelector('html').scrollWidth;
                    var bodyWidth = _this.getContentDocument().querySelector('body').scrollWidth;
                    // update iframe size
                    _this.iframeHeight = Math.max(htmlHeight, bodyHeight) + "px";
                    _this.iframeWidth = Math.max(htmlWidth, bodyWidth) + "px";
                    resolve();
                });
            });
        };
        NgSimpleMarkdownViewerDirective.prototype.filterHTML = function (html) {
            // parse HTML
            var dom = (new DOMParser()).parseFromString(html, 'text/html');
            // hide excess content
            var htmlTag = dom.querySelector('html');
            if (htmlTag) {
                htmlTag.style.overflow = 'hidden';
            }
            // set link target
            var links = dom.querySelectorAll('a');
            for (var i = 0; i < links.length; i++) {
                links.item(i).setAttribute('target', '_blank');
            }
            // set mention tag url
            if (this.getTagUrl) {
                var mentionTags = dom.querySelectorAll('[data-mention-tag]');
                for (var i = 0; i < mentionTags.length; i++) {
                    var value = mentionTags.item(i).dataset.mentionTag;
                    mentionTags.item(i).setAttribute('href', this.getTagUrl(value));
                }
            }
            // convert back to string
            return (new XMLSerializer()).serializeToString(dom);
        };
        return NgSimpleMarkdownViewerDirective;
    }());
    NgSimpleMarkdownViewerDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[ngSimpleMarkdownViewer]',
                },] }
    ];
    NgSimpleMarkdownViewerDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: NgSimpleMarkdownService },
        { type: platformBrowser.DomSanitizer }
    ]; };
    NgSimpleMarkdownViewerDirective.propDecorators = {
        markdown: [{ type: core.Input }],
        styles: [{ type: core.Input }],
        getTagUrl: [{ type: core.Input }],
        mentions: [{ type: core.Output }],
        mentionWithIds: [{ type: core.Output }],
        ready: [{ type: core.Output }],
        tags: [{ type: core.Output }],
        taskLists: [{ type: core.Output }],
        border: [{ type: core.HostBinding, args: ['style.border',] }],
        iframeHeight: [{ type: core.HostBinding, args: ['style.height',] }],
        iframeWidth: [{ type: core.HostBinding, args: ['style.width',] }],
        onLoad: [{ type: core.HostListener, args: ['load',] }]
    };

    var NgSimpleMarkdownEditorModule = /** @class */ (function () {
        function NgSimpleMarkdownEditorModule() {
        }
        return NgSimpleMarkdownEditorModule;
    }());
    NgSimpleMarkdownEditorModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NgSimpleMarkdownEditorComponent,
                        NgSimpleMarkdownMentionDirective,
                        NgSimpleMarkdownMentionsComponent,
                        NgSimpleMarkdownTextPreviewPipe,
                        NgSimpleMarkdownViewerDirective,
                    ],
                    exports: [
                        NgSimpleMarkdownEditorComponent,
                        NgSimpleMarkdownTextPreviewPipe,
                        NgSimpleMarkdownViewerDirective,
                    ],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        button.MatButtonModule,
                        icon.MatIconModule,
                        list.MatListModule,
                        forms.ReactiveFormsModule,
                        textField.TextFieldModule,
                    ],
                    providers: [
                        NgSimpleMarkdownService,
                    ],
                },] }
    ];

    /*
     * Public API Surface of ng-simple-markdown-editor
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgSimpleMarkdownEditorComponent = NgSimpleMarkdownEditorComponent;
    exports.NgSimpleMarkdownEditorModule = NgSimpleMarkdownEditorModule;
    exports.NgSimpleMarkdownService = NgSimpleMarkdownService;
    exports.NgSimpleMarkdownTextPreviewPipe = NgSimpleMarkdownTextPreviewPipe;
    exports.NgSimpleMarkdownViewerDirective = NgSimpleMarkdownViewerDirective;
    exports.ɵa = NgSimpleMarkdownMentionDirective;
    exports.ɵb = NgSimpleMarkdownMentionsComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-simple-markdown-editor.umd.js.map
