import { Overlay } from '@angular/cdk/overlay';
import { ElementRef, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
export declare class NgSimpleMarkdownMentionDirective implements OnInit, OnDestroy, OnChanges {
    private elementRef;
    private overlay;
    private configs;
    private cursorPosition;
    private searchResult;
    private searchTerm;
    menuOpened: boolean;
    private itemCount;
    private triggerCharPosition;
    private triggerChar;
    private triggerTerm;
    private triggerMap;
    private overlayRef;
    private componentRef;
    private countSubscription;
    private destroySubscription;
    private selectSubscription;
    private searchTermDebounceSubscription;
    private searchTermDebounce;
    constructor(elementRef: ElementRef<HTMLTextAreaElement>, overlay: Overlay);
    onInput(event: InputEvent): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    closeMenu(): void;
    private openMenu;
    private getPositionStrategy;
    private updateMenuPosition;
    private emitSearchTerm;
    private dispose;
}
