import { ElementRef, OnChanges, SimpleChanges } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { NgSimpleMarkdownService } from './ng-simple-markdown.service';
export declare class NgSimpleMarkdownViewerDirective implements OnChanges {
    private elementRef;
    private ngSimpleMarkdownService;
    private sanitizer;
    markdown: string;
    styles: string;
    getTagUrl: (tag: string) => string;
    private mentions;
    private mentionWithIds;
    private ready;
    private tags;
    private taskLists;
    border: string;
    iframeHeight: string;
    iframeWidth: string;
    private iframeDocument;
    private iframeStyle;
    constructor(elementRef: ElementRef<HTMLIFrameElement>, ngSimpleMarkdownService: NgSimpleMarkdownService, sanitizer: DomSanitizer);
    getContentDocument(): Document;
    onLoad(): Promise<void>;
    ngOnChanges(changes: SimpleChanges): void;
    updateSize(): Promise<void>;
    private filterHTML;
}
